//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef INST_INST_TASKS_HH
# define INST_INST_TASKS_HH

# include "task/libtask.hh"

namespace inst
{

  namespace tasks
  {

    TASK_MODULE ("2. Instructions");

    TASK_DECLARE ("prg-display",
                  "Display the read program",
                  prg_display, "parse");

    TASK_DECLARE ("prg-solve",
                  "Resolve jump offsets and check bounds of immediates",
                  prg_solve, "parse");

    INT_TASK_DECLARE ("callee-save",
                      "Set max number of callee-save registers",
                      max_callee_save, 8, 0, 8,
                      "");
    INT_TASK_DECLARE ("caller-save",
                      "Set max number of caller-save registers",
                      max_caller_save, 10, 0, 10,
                      "");
    INT_TASK_DECLARE ("argument-registers",
                      "Set max number of argument registers",
                      max_args, 4, 0, 4,
                      "");
  } // namespace tasks

} // namespace inst

#endif // !INST_INST_TASKS_HH
