//
// This file is part of Nolimips, a MIPS simulator with unlimited registers
// Copyright (C) 2003, 2004, 2006 Benoit Perrot <benoit@lrde.epita.fr>
//
// Nolimips is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// Nolimips is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Nolimips.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef INST_PROGRAM_HH
# define INST_PROGRAM_HH

# include <ostream>

# include "inst/text_section.hh"
# include "inst/data_section.hh"

namespace inst
{

  class Program
  {
  public:
    TextSection &text_section();
    const TextSection &text_section() const;

  public:
    DataSection &data_section();
    const DataSection &data_section() const;

  public:
    void write(std::ostream &ostr) const;

  protected:
    TextSection text_section_;
    DataSection data_section_;
  };

  std::ostream &
  operator<<(std::ostream &ostr, const Program &p);

} // namespace inst

# include "inst/program.hxx"

#endif // !INST_PROGRAM_HH
